whenQuiLoaded().then(function () {
    "use strict";

    function isOrderInstalled() {
        return new Promise(function (resolve) {
            require(['Packages'], function (Packages) {
                Packages.isInstalled('quiqqer/order').then(resolve);
            });
        });
    }

    isOrderInstalled().then(function (isInstalled) {
        if (!isInstalled) {
            return;
        }

        require([
            'package/quiqqer/order/bin/frontend/Basket',
            'package/quiqqer/order/bin/frontend/classes/Product',
            'package/quiqqer/order/bin/frontend/Orders'
        ], function (Basket, BasketProduct, Orders) {
            const buttons = document.getElements('.quiqqer-affiliate-products-col-button button');

            buttons.setStyle('position', 'relative');
            buttons.addEvent('click', function (event) {
                let Target = event.target;

                if (Target.nodeName !== 'BUTTON') {
                    Target = Target.getParent('button');
                }

                if (Target.getElement('.quiqqer-button-add-loader')) {
                    return;
                }

                Target.disabled = true;

                const Text = Target.getElement('span');
                const openCart = parseInt(Target.get('data-open-cart'));

                const Loader = new Element('div', {
                    'class': 'quiqqer-affiliate-button-add-loader',
                    html   : '<span class="fa fa-spinner fa-spin"></span>',
                    styles : {
                        height        : '100%',
                        left          : 0,
                        position      : 'absolute',
                        top           : 0,
                        width         : '100%',
                        display       : 'flex',
                        alignItems    : 'center',
                        justifyContent: 'center'
                    }
                }).inject(Target);

                Text.setStyle('visibility', 'hidden');

                const Product = new BasketProduct({
                    id: Target.getAttribute('data-product-id')
                });

                Product.setQuantity(1).then(function () {
                    return Basket.addProduct(Product);
                }).then(function () {
                    const Span = Loader.getElement('span');
                    Span.removeClass('fa-spinner');
                    Span.removeClass('fa-spin');
                    Span.addClass('success');
                    Span.addClass('fa-check');

                    (function () {
                        // go to the checkout if needed
                        if (openCart) {
                            Orders.getOrderProcessUrl().then(function (url) {
                                window.location = url;
                            });

                            return;
                        }
                        
                        moofx(Loader).animate({
                            opacity: 0
                        }, {
                            duration: 300,
                            callback: function () {
                                Loader.destroy();
                                Text.setStyle('visibility', null);
                            }
                        });

                        Target.disabled = false;
                    }).delay(1000);
                }).catch(function () {
                    const Span = Loader.getElement('span');
                    Span.removeClass('fa-spinner');
                    Span.removeClass('fa-spin');
                    Span.addClass('error');
                    Span.addClass('fa-bolt');

                    (function () {
                        moofx(Loader).animate({
                            opacity: 0
                        }, {
                            duration: 300,
                            callback: function () {
                                Loader.destroy();
                                Text.setStyle('visibility', null);
                            }
                        });

                        Target.disabled = false;
                    }).delay(1000);
                });
            });

            buttons.set('disabled', false);
        });
    });
});