<?php

namespace QUI\ERP\Products\Affiliate\Controls;

use QUI;

/**
 * Class AffiliateFields
 */
class AffiliateFields extends QUI\Control
{
    public function __construct($attributes = [])
    {
        parent::__construct($attributes);

        $this->addCSSClass('quiqqer-affiliate-product-fields');
        $this->addCSSFile(\dirname(__FILE__).'/AffiliateFields.css');
    }

    /**
     * @return string
     * @throws QUI\Exception
     */
    public function getBody()
    {
        /* @var $Product QUI\ERP\Products\Product\Product */

        $Engine  = QUI::getTemplateManager()->getEngine();
        $Product = $this->getAttribute('Product');

        if (!$Product) {
            return '';
        }

        $fields = QUI\ERP\Products\Utils\Fields::sortFields(
            $Product->getFieldsByType('affiliate-products.AffiliateRatingType')
        );

        $fields = \array_map(function ($Field) {
            return $Field->getView();
        }, $fields);

        $Engine->assign([
            'fields' => $fields
        ]);

        return $Engine->fetch(\dirname(__FILE__).'/AffiliateFields.html');
    }
}
