<?php

namespace QUI\ERP\Products\Affiliate\Fields;

use QUI;
use function GuzzleHttp\Promise\queue;

/**
 * Class AffiliateRatingTypeFrontendView
 *
 * Frontend view control for AffiliateRatingType fields.
 */
class AffiliateRatingTypeFrontendView extends QUI\ERP\Products\Field\View
{
    /**
     * Render the view, return the html
     *
     * @return string
     * @throws QUI\Exception
     */
    public function create()
    {
        if (!$this->hasViewPermission()) {
            return '';
        }

        $Engine = QUI::getTemplateManager()->getEngine();
        $value  = $this->getValue();

        if (empty($value['criteria'])) {
            return '---';
        }

        $options = $this->getOptions();

        // Sort criteria by pos
        \uksort($value['criteria'], function ($a, $b) use ($options) {
            return (int)$options['criteria'][$b]['pos'] - (int)$options['criteria'][$a]['pos'];
        });

        $Engine->assign([
            'title'   => $this->getTitle(),
            'value'   => $value,
            'options' => $options,
            'lang'    => QUI::getLocale()->getCurrent()
        ]);

        return $Engine->fetch(\dirname(__FILE__).'/AffiliateRatingTypeFrontendView.html');
    }
}
