<?php

namespace QUI\ERP\Products\Affiliate;

use QUI;
use QUI\ERP\Products\Handler\Fields;
use QUI\ERP\Products\Handler\Search;

/**
 * Class Setup - Setup helper for the affiliate module
 */
class Setup
{
    /**
     * Runs the setup
     */
    public static function execute()
    {
        $affiliateFields = [
            // Affiliate Link
            [
                'id'            => AffiliateProducts::FIELD_AFFILIATE_LINK,
                'type'          => 'Input',
                'prefix'        => '',
                'suffix'        => '',
                'priority'      => 10,
                'systemField'   => 1,
                'standardField' => 1,
                'requiredField' => 0,
                'publicField'   => 1,
                'search_type'   => Search::SEARCHTYPE_TEXT,
                'titles'        => [
                    'de' => 'Affiliate Link',
                    'en' => 'Affiliate link'
                ]
            ],
            [
                'id'            => AffiliateProducts::FIELD_AFFILIATE_LINK_TEXT,
                'type'          => 'Input',
                'prefix'        => '',
                'suffix'        => '',
                'priority'      => 11,
                'systemField'   => 1,
                'standardField' => 1,
                'requiredField' => 0,
                'publicField'   => 1,
                'search_type'   => Search::SEARCHTYPE_TEXT,
                'titles'        => [
                    'de' => 'Affiliate Linktext',
                    'en' => 'Affiliate link text'
                ]
            ]
        ];

        foreach ($affiliateFields as $field) {
            try {
                Fields::getField($field['id']);
                continue;
            } catch (QUI\Exception $Exception) {
                // feld gibt es noch nicht
                // dann weiter
            }

            try {
                Fields::createField($field);
            } catch (\Exception $Exception) {
                QUI\System\Log::writeException($Exception);
            }
        }
    }
}
