<?php

use QUI\ERP\Products\Product\ViewFrontend;

$products = $Site->getAttribute('quiqqer.affiliate.products');
$products = \trim($products, ',');
$products = \explode(',', $products);

$productList = [];

foreach ($products as $product) {
    try {
        $Product = \QUI\ERP\Products\Handler\Products::getProduct($product);

        if ($Product->isActive()) {
            $productList[] = $Product->getViewFrontend();
        }
    } catch (QUI\Exception $Exception) {
        QUI\System\Log::writeRecursive($Exception->getMessage());
    }
}


$Utils = new class {
    public function getFields(ViewFrontend $Product): array
    {
        $fields = QUI\ERP\Products\Utils\Fields::sortFields(
            $Product->getFieldsByType('affiliate-products.AffiliateRatingType')
        );

        $fields = array_map(function ($Field) {
            return $Field->getView();
        }, $fields);

        return $fields;
    }
};

$fields = [];

if (isset($productList[0])) {
    $fields = $Utils->getFields($productList[0]);
}

$Engine->assign([
    'productList' => $productList,
    'Utils'       => $Utils,
    'mainFields'  => $fields,

    'addToShoppingCart' => $Site->getAttribute('quiqqer.affiliate.products.add.to.shoppingCart'),
    'openShoppingCart'  => $Site->getAttribute('quiqqer.affiliate.products.open.shoppingCart') ? 1 : 0
]);
